"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Label = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const react_native_unistyles_1 = require("react-native-unistyles");
const enums_1 = require("@procyon/types/enums");
const Label = ({ label, style }) => {
    const { styles } = (0, react_native_unistyles_1.useStyles)(styleSheet);
    return react_1.default.createElement(react_native_1.Text, { style: [styles.procyon_textField_label(), style] }, label);
};
exports.Label = Label;
const styleSheet = (0, react_native_unistyles_1.createStyleSheet)((theme) => {
    return {
        procyon_textField_label: () => {
            const variantForSize = (size) => ({
                padding: theme.spacing[size],
                fontSize: theme.fontSize[size],
            });
            return {
                color: theme.components.field.label.color,
                backgroundColor: theme.components.field.label.background,
                fontFamily: theme.fontFamily,
                variants: {
                    disabled: {
                        true: {
                            color: theme.components.field.disabled.color,
                        },
                    },
                    size: {
                        [enums_1.SizeEnum.sm]: variantForSize(enums_1.SizeEnum.sm),
                        [enums_1.SizeEnum.md]: variantForSize(enums_1.SizeEnum.md),
                        [enums_1.SizeEnum.lg]: variantForSize(enums_1.SizeEnum.lg),
                        [enums_1.SizeEnum.xl]: variantForSize(enums_1.SizeEnum.xl),
                    },
                },
                paddingLeft: 2,
                paddingBottom: 4,
            };
        },
    };
});
