"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modals = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_unistyles_1 = require("react-native-unistyles");
const utils_1 = require("@procyon/utils");
const useModal_1 = require("../useModal");
const Modals = () => {
    const [, , { modals, opened, closeModal }] = (0, useModal_1.useModal)();
    const { styles } = (0, react_native_unistyles_1.useStyles)(styleSheet);
    const handleCloseModal = (modalId) => {
        var _a, _b, _c;
        (_c = (_b = (_a = modals[modalId]) === null || _a === void 0 ? void 0 : _a.props) === null || _b === void 0 ? void 0 : _b.onClose) === null || _c === void 0 ? void 0 : _c.call(_b);
        closeModal(modalId);
    };
    const handleKeyUp = (e) => {
        if (e.key === 'Escape') {
            const modalId = opened.at(-1);
            if (modalId !== undefined) {
                handleCloseModal(modalId);
            }
        }
    };
    (0, react_1.useEffect)(() => {
        window.addEventListener('keydown', handleKeyUp);
        return () => {
            window.removeEventListener('keydown', handleKeyUp);
        };
    }, [handleKeyUp]);
    if ((0, utils_1.isNilOrEmpty)(opened)) {
        return null;
    }
    return opened.map((modalId) => {
        var _a;
        const { id, style, title, Component, props } = (_a = modals[modalId]) !== null && _a !== void 0 ? _a : {};
        if (!id)
            return null;
        return (react_1.default.createElement(react_native_1.Pressable, { key: id, style: [styles.procyon_modal_wrapper, style === null || style === void 0 ? void 0 : style.wrapper], onPress: () => handleCloseModal(id) },
            react_1.default.createElement(react_native_1.Pressable, { style: [styles.procyon_modal_container, style === null || style === void 0 ? void 0 : style.container], onPress: (e) => e.preventDefault() },
                title && (react_1.default.createElement(react_native_1.Text, { style: [styles.procyon_modal_title, style === null || style === void 0 ? void 0 : style.title] }, title)),
                react_1.default.createElement(react_native_1.View, { style: [styles.procyon_modal_body, style === null || style === void 0 ? void 0 : style.body] }, Component && react_1.default.createElement(Component, Object.assign({}, props))))));
    });
};
exports.Modals = Modals;
const styleSheet = (0, react_native_unistyles_1.createStyleSheet)((theme) => ({
    procyon_modal_wrapper: {
        position: 'absolute',
        top: 0,
        right: 0,
        bottom: 0,
        left: 0,
        backgroundColor: 'rgba(57,58,52,0.25)',
    },
    procyon_modal_container: {
        cursor: 'auto',
        minWidth: 200,
        marginVertical: 'auto',
        marginHorizontal: 'auto',
        padding: theme.spacing.lg,
        backgroundColor: theme.components.modal.container.background,
        borderWidth: 2,
        borderColor: theme.components.modal.container.none.border,
        borderRadius: theme.spacing.md,
    },
    procyon_modal_title: {
        fontSize: theme.fontSize.lg,
        fontFamily: theme.fontFamily,
        borderBottomWidth: 1,
        borderBottomColor: theme.components.modal.container.none.border,
        paddingHorizontal: theme.spacing.md,
        paddingBottom: theme.spacing.md,
        marginBottom: 10,
    },
    procyon_modal_body: {},
}));
